<?php

namespace App\Helpers\Equipment;

use App\Models\Equipment\ServerModel;

class ServerHelper extends EquipmentHelper
{
    public function __construct()
    {
        parent::__construct();
        $this->setTitleField(field: ServerModel::TITLE);
    }
    public function getFieldForm(string $field, mixed $value, array $viewDatas, array $extras = []): string
    {
        switch ($field) {
            case 'code':
                // $extras['readonly']  = in_array($viewDatas['control']['action'], ['modify_form']) ?  ' readonly' : '';
                $form = parent::getFieldForm($field, $value, $viewDatas, $extras);
                break;
            case 'manufactur_at':
            case 'format_at':
                $extras['class'] = array_key_exists('class', $extras) ? $extras['class'] . ' calender' : 'calender';
                $form = form_input($field, $value ?? "", $extras);
                break;
            default:
                $form = parent::getFieldForm($field, $value, $viewDatas, $extras);
                break;
        }
        return $form;
    }
    public function getFieldView(string $field, mixed $value, array $viewDatas, array $extras = []): string|null
    {
        switch ($field) {
            case 'clientinfo_uid':
                if (array_key_exists($value, $viewDatas['control']['field_optons'][$field])) {
                    $value = "<a href=\"/admin/customer/client/detail/{$value}\">" . $viewDatas['control']['field_optons'][$field][$value]->getTitle() . "</a>";
                }
                break;
            case 'manufactur_at':
            case 'format_at':
                $value = $value ? date("Y-m-d", strtotime($value)) : "";
                break;
            default:
                $value = parent::getFieldView($field, $value, $viewDatas, $extras);
                break;
        }
        if (is_array($value)) {
            echo __METHOD__ . "에서 오류: {$field}의 값이 Array형태입니다";
            exit;
        }
        return $value;
    }
    public function getListButton(string $action, string $label, array $viewDatas, array $extras = []): string
    {
        switch ($action) {
            case 'modify':
                $action = parent::getListButton($action, $label ? $label : $viewDatas['entity']->getCode(), $viewDatas, $extras);
                break;
            case 'history':
                $extras = ["class" => "btn btn-outline btn-primary btn-circle", "target" => "_self", ...$extras];
                $action = $label ? $label : form_label(
                    $label ? $label : ICONS['HISTORY'],
                    $action,
                    [
                        "data-src" => "/admin/customer/clienthistory?clientinfo_uid={$viewDatas['entity']->getPK()}",
                        "data-bs-toggle" => "modal",
                        "data-bs-target" => "#index_action_form",
                        ...$extras
                    ]
                );
                break;
            default:
                $action = parent::getListButton($action, $label, $viewDatas, $extras);
                break;
        }
        return $action;
    }
}
